3a04db785167b9225ddf41a5704cbdc096e5f060
[koha-equinox.git] / debian / scripts / koha-functions.sh
1 #!/bin/sh
2 #
3 # koha-functions.sh -- shared library of helper functions for koha-* scripts
4 # Copyright 2014 - Tomas Cohen Arazi
5 #                  Universidad Nacional de Cordoba
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20
21 die()
22 {
23     echo "$@" 1>&2
24     exit 1
25 }
26
27 warn()
28 {
29     echo "$@" 1>&2
30 }
31
32 get_apache_config_for()
33 {
34     local site=$1
35     local sitefile="/etc/apache2/sites-available/$site"
36
37     if is_instance $site; then
38         if [ -f "$sitefile.conf" ]; then
39             echo "$sitefile.conf"
40         elif [ -f "$sitefile" ]; then
41             echo "$sitefile"
42         fi
43     fi
44 }
45
46 get_opacdomain_for()
47 {
48     local site=$1
49
50     if [ -e /etc/koha/koha-sites.conf ]; then
51         . /etc/koha/koha-sites.conf
52     else
53         echo "Error: /etc/koha/koha-sites.conf not present." 1>&2
54         exit 1
55     fi
56     local opacdomain="$OPACPREFIX$site$OPACSUFFIX$DOMAIN"
57     echo "$opacdomain"
58 }
59
60 get_intradomain_for()
61 {
62     local site=$1
63
64     if [ -e /etc/koha/koha-sites.conf ]; then
65         . /etc/koha/koha-sites.conf
66     else
67         echo "Error: /etc/koha/koha-sites.conf not present." 1>&2
68         exit 1
69     fi
70     local intradomain="$INTRAPREFIX$site$INTRASUFFIX$DOMAIN"
71     echo "$intradomain"
72 }
73
74 letsencrypt_get_opacdomain_for()
75 {
76     local site=$1
77
78     if [ -e /var/lib/koha/$site/letsencrypt.enabled ]; then
79         . /var/lib/koha/$site/letsencrypt.enabled
80     else
81         local opacdomain=$(get_opacdomain_for $site)
82     fi
83     echo "$opacdomain"
84 }
85
86 is_enabled()
87 {
88     local site=$1
89     local instancefile=$(get_apache_config_for $site)
90
91     if [ "$instancefile" = "" ]; then
92         return 1
93     fi
94
95     if grep -q '^[[:space:]]*Include /etc/koha/apache-shared-disable.conf' \
96             "$instancefile" ; then
97         return 1
98     else
99         return 0
100     fi
101 }
102
103 is_instance()
104 {
105     local instancename=$1
106
107     if find -L /etc/koha/sites -mindepth 1 -maxdepth 1 \
108                          -type d -printf '%f\n'\
109           | grep -q -x "$instancename" ; then
110         return 0
111     else
112         return 1
113     fi
114 }
115
116 is_email_enabled()
117 {
118     local instancename=$1
119
120     if [ -e /var/lib/koha/$instancename/email.enabled ]; then
121         return 0
122     else
123         return 1
124     fi
125 }
126
127 is_letsencrypt_enabled()
128 {
129     local instancename=$1
130
131     if [ -e /var/lib/koha/$instancename/letsencrypt.enabled ]; then
132         return 0
133     else
134         return 1
135     fi
136 }
137
138 is_sip_enabled()
139 {
140     local instancename=$1
141
142     if [ -e /etc/koha/sites/$instancename/SIPconfig.xml ]; then
143         return 0
144     else
145         return 1
146     fi
147 }
148
149 is_sitemap_enabled()
150 {
151     local instancename=$1
152
153     if [ -e /var/lib/koha/$instancename/sitemap.enabled ]; then
154         return 0
155     else
156         return 1
157     fi
158 }
159
160 is_sip_running()
161 {
162     local instancename=$1
163
164     if daemon --name="$instancename-koha-sip" \
165             --pidfiles="/var/run/koha/$instancename/" \
166             --user="$instancename-koha.$instancename-koha" \
167             --running ; then
168         return 0
169     else
170         return 1
171     fi
172 }
173
174 is_zebra_running()
175 {
176     local instancename=$1
177
178     if daemon --name="$instancename-koha-zebra" \
179             --pidfiles="/var/run/koha/$instancename/" \
180             --user="$instancename-koha.$instancename-koha" \
181             --running ; then
182         return 0
183     else
184         return 1
185     fi
186 }
187
188 is_indexer_running()
189 {
190     local instancename=$1
191
192     if daemon --name="$instancename-koha-indexer" \
193             --pidfiles="/var/run/koha/$instancename/" \
194             --user="$instancename-koha.$instancename-koha" \
195             --running ; then
196         return 0
197     else
198         return 1
199     fi
200 }
201
202 is_plack_enabled()
203 {
204     local site=$1
205     local instancefile=$(get_apache_config_for $site)
206
207     if [ "$instancefile" = "" ]; then
208         return 1
209     fi
210
211     if grep -q '^[[:space:]]*Include /etc/koha/apache-shared-opac-plack.conf' \
212             "$instancefile" && \
213        grep -q '^[[:space:]]*Include /etc/koha/apache-shared-intranet-plack.conf' \
214             "$instancefile" ; then
215         return 0
216     else
217         return 1
218     fi
219 }
220
221 is_plack_running()
222 {
223     local instancename=$1
224
225     if start-stop-daemon --pidfile "/var/run/koha/${instancename}/plack.pid" \
226             --status ; then
227         return 0
228     else
229         return 1
230     fi
231 }
232
233 adjust_paths_dev_install()
234 {
235 # Adjust KOHA_HOME, PERL5LIB for dev installs, as indicated by
236 # corresponding tag in koha-conf.xml
237
238     local instancename=$1
239     local dev_install=""
240
241     if [ "$instancename" != "" ] && is_instance $instancename; then
242         dev_install=$(run_safe_xmlstarlet $instancename dev_install)
243     fi
244
245     if [ "$dev_install" != "" ] && [ "$dev_install" != "0" ]; then
246         DEV_INSTALL=1
247         KOHA_HOME=$(run_safe_xmlstarlet $instancename intranetdir)
248         PERL5LIB=$KOHA_HOME
249     else
250         DEV_INSTALL=""
251     fi
252 }
253
254 get_instances()
255 {
256     find -L /etc/koha/sites -mindepth 1 -maxdepth 1\
257                          -type d -printf '%f\n' | sort
258 }
259
260 get_loglevels()
261 {
262     local instancename=$1
263     local retval=$(run_safe_xmlstarlet $instancename zebra_loglevels)
264     if [ "$retval" != "" ]; then
265         echo "$retval"
266     else
267         echo "none,fatal,warn"
268     fi
269 }
270
271 get_max_record_size()
272 {
273     local instancename=$1
274     local retval=$(xmlstarlet sel -t -v 'yazgfs/config/zebra_max_record_size' /etc/koha/sites/$instancename/koha-conf.xml)
275     if [ "$retval" != "" ]; then
276         echo "$retval"
277     else
278         echo "1024"
279     fi
280 }
281
282 get_tmpdir()
283 {
284     if [ "$TMPDIR" != "" ]; then
285         if [ -d "$TMPDIR" ]; then
286             echo $TMPDIR
287             return 0
288         fi
289         # We will not unset TMPDIR but just default to /tmp here
290         # Note that mktemp (used later) would look at TMPDIR
291         echo "/tmp"
292         return 0
293     fi
294     local retval=$(mktemp -u)
295     if [ "$retval" = "" ]; then
296         echo "/tmp"
297         return 0
298     fi
299     echo $(dirname $retval)
300 }
301
302 run_safe_xmlstarlet()
303 {
304     # When a bash script sets -e (errexit), calling xmlstarlet on an
305     # unexisting key would halt the script. This is resolved by calling
306     # this function in a subshell. It will always returns true, while not
307     # affecting the exec env of the caller. (Otherwise, errexit is cleared.)
308     local instancename=$1
309     local myexpr=$2
310     set +e; # stay on the safe side
311     echo $(xmlstarlet sel -t -v "yazgfs/config/$myexpr" /etc/koha/sites/$instancename/koha-conf.xml)
312     return 0
313 }